<?xml version="1.0" encoding="UTF-8"?>
<!-- {{ ansible_managed }} -->
<!-- public_ip: {{ hostvars[inventory_hostname].public_ip }} -->
<!-- OME Version: {{ ome_version }} -->



<Server version="8">
	<Name>{{ ome_server_name }}</Name>
	<!-- Host type (origin/edge) -->
	<Type>{{ ome_server_type }}</Type>
	<!-- Specify IP address to bind (* means all IPs) -->
	<!-- <IP>{{ hostvars[inventory_hostname].public_ip }}</IP> (funktioniert auf cloud servern nicht, da sie intern ne andere IP haben und deshalb nicht zur externen IP binden können)-->
	<IP>{{ ome_server_ip }}</IP>

	<!-- 
	To get the public IP address(mapped address of stun) of the local server. 
	This is useful when OME cannot obtain a public IP from an interface, such as AWS or docker environment. 
	If this is successful, you can use ${PublicIP} in your settings.
	-->
	<!-- <StunServer>stun.l.google.com:19302</StunServer> -->

	<!-- Settings for the ports to bind -->
	<Bind>
		<!-- Enable this configuration if you want to use API Server -->
{% if ome_api.enabled %}
		<Managers>
			<API>
				<Port>{{ ome_ports.api }}</Port>
				<WorkerCount>{{ ome_workercounts.api }}</WorkerCount>
			</API>
		</Managers>
{% endif %}

		<Providers>
			<!-- Pull providers -->
{% if 'RTSPC' in ome_enabled_providers %}
			<RTSPC>
				<WorkerCount>{{ ome_workercounts.providers.rtspc }}</WorkerCount>
			</RTSPC>
{% endif %}
{% if 'OVT' in ome_enabled_providers %}
			<OVT>
				<WorkerCount>{{ ome_workercounts.providers.ovt }}</WorkerCount>
			</OVT>
{% endif %}
			<!-- Push providers -->
{% if 'RTMP' in ome_enabled_providers %}
			<RTMP>
				<Port>{{ ome_ports.providers.rtmp }}</Port>
				<WorkerCount>{{ ome_workercounts.providers.rtmp }}</WorkerCount>
			</RTMP>
{% endif %}
{% if 'SRT' in ome_enabled_providers %}
			<SRT>
				<Port>{{ ome_ports.providers.srt }}</Port>
				<WorkerCount>{{ ome_workercounts.providers.srt }}</WorkerCount>
			</SRT>
{% endif %}
{% if 'MPEGTS' in ome_enabled_providers %}
			<MPEGTS>
				<!--
					Listen on port 4000~4005
					This is just a demonstration to show that you can configure the port in several ways
				-->
				<Port>{{ ome_ports.providers.mpegts }}</Port>
			</MPEGTS>
{% endif %}
{% if 'WebRTC' in ome_enabled_providers %}
			<WebRTC>
				<Signalling>
					<Port>{{ ome_ports.providers.webrtc.signalling }}</Port>
{% if ome_tls.enabled %}
						<TLSPort>{{ ome_ports.providers.webrtc.signalling_tls }}</TLSPort>
{% endif %}
					<WorkerCount>{{ ome_workercounts.providers.webrtc.signalling }}</WorkerCount>
				</Signalling>

				<IceCandidates>
					<!-- 
						If you want to stream WebRTC over TCP, specify IP:Port for TURN server.
						This uses the TURN protocol, which delivers the stream from the built-in TURN server to the player's TURN client over TCP. 
						For detailed information, refer https://airensoft.gitbook.io/ovenmediaengine/streaming/webrtc-publishing#webrtc-over-tcp
						<TcpRelay>{{ hostvars[inventory_hostname].public_ip }}:ome_ports.providers.webrtc.icecandidates_tcprelay</TcpRelay>
					-->
					<IceCandidate>{{ hostvars[inventory_hostname].public_ip }}:{{ ome_ports.providers.webrtc.icecandidates }}</IceCandidate>
					<TcpForce>false</TcpForce>

					<!--
						Sets the number of worker threads to use in TcpRelay
						
						<TcpRelayWorkerCount>4</TcpRelayWorkerCount>
						<TcpRelayWorkerCount>1</TcpRelayWorkerCount>
					-->
				</IceCandidates>
			</WebRTC>
{% endif %}
		</Providers>

		<Publishers>
{% if 'OVT' in ome_enabled_publishers %}
			<OVT>
				<Port>{{ ome_ports.publishers.ovt }}</Port>
				<WorkerCount>{{ ome_workercounts.publishers.ovt }}</WorkerCount>
			</OVT>
{% endif %}
{% if 'HLS' in ome_enabled_publishers %}
			<HLS>
				<Port>{{ ome_ports.publishers.hls }}</Port>
{% if ome_tls.enabled %}
				<TLSPort>{{ ome_ports.publishers.hls_tls }}</TLSPort>
{% endif %}
				<WorkerCount>{{ ome_workercounts.publishers.hls }}</WorkerCount>
			</HLS>
{% endif %}
{% if 'DASH' in ome_enabled_publishers %}
			<DASH>
				<Port>{{ ome_ports.publishers.dash }}</Port>
{% if ome_tls.enabled %}
				<TLSPort>{{ ome_ports.publishers.dash_tls }}</TLSPort>
{% endif %}
				<WorkerCount>{{ ome_workercounts.publishers.dash }}</WorkerCount>
			</DASH>
{% endif %}
{% if 'WebRTC' in ome_enabled_publishers %}
			<WebRTC>
				<Signalling>
					<Port>{{ ome_ports.publishers.webrtc.signalling }}</Port>
{% if ome_tls.enabled %}
					<TLSPort>{{ ome_ports.publishers.webrtc.signalling_tls }}</TLSPort>
{% endif %}
					<WorkerCount>{{ ome_workercounts.publishers.webrtc.signalling }}</WorkerCount>
				</Signalling>
				<IceCandidates>
					<!-- 
						If you want to stream WebRTC over TCP, specify IP:Port for TURN server.
						This uses the TURN protocol, which delivers the stream from the built-in TURN server to the player's TURN client over TCP. 
						For detailed information, refer https://airensoft.gitbook.io/ovenmediaengine/v/0.11.1/streaming/webrtc-publishing#webrtc-over-tcp
						<TcpRelay>{{ hostvars[inventory_hostname].public_ip }}:ome_ports.providers.webrtc.icecandidates_tcprelay</TcpRelay>
					-->
					<IceCandidate>{{ hostvars[inventory_hostname].public_ip }}:{{ ome_ports.publishers.webrtc.icecandidates }}</IceCandidate>
					<TcpForce>false</TcpForce>

					<!--
						Sets the number of worker threads to use in TcpRelay
					<TcpRelayWorkerCount>1</TcpRelayWorkerCount>
					-->
				</IceCandidates>
			</WebRTC>
{% endif %}
{% if 'Thumbnail' in ome_enabled_publishers %}
			<Thumbnail>
				<Port>{{ ome_ports.publishers.hls }}</Port>
{% if ome_tls.enabled %}
				<TLSPort>{{ ome_ports.publishers.hls_tls }}</TLSPort>
{% endif %}
			</Thumbnail>
{% endif %}
		</Publishers>
	</Bind>

	<!-- P2P works only in WebRTC -->
	<!--
	<P2P>
		<MaxClientPeersPerHostPeer>2</MaxClientPeersPerHostPeer>
	</P2P>
	-->

	<!--
		Enable this configuration if you want to use API Server
		
		<AccessToken> is a token for authentication, and when you invoke the API, you must put "Basic base64encode(<AccessToken>)" in the "Authorization" header of HTTP request.
		For example, if you set <AccessToken> to "ome-access-token", you must set "Basic b21lLWFjY2Vzcy10b2tlbg==" in the "Authorization" header.
	-->
{% if ome_api.enabled %}
	<Managers>
		<Host>
			<Names>
				<Name>*</Name>
			</Names>
{% if ome_tls.enabled %}
			<TLS>
				<CertPath>{{ ome_tls.certpath }}</CertPath>
				<KeyPath>{{ ome_tls.keypath }}</KeyPath>
				<ChainCertPath>{{ ome_tls.chaincertpath }}</ChainCertPath>
			</TLS>
{% endif %}
		</Host>
		<API>
			<AccessToken>{{ ome_api.accesstoken }}</AccessToken>
		</API>
	</Managers>
{% endif %}

	<VirtualHosts>
		<!-- You can use wildcard like this to include multiple XMLs -->
		<!-- <VirtualHost include="VHost*.xml" /> -->
{% for vh in ome_virtualhosts_includes %}
		<VirtualHost include="{{ vh }}" />
{% endfor %}
{% for vh in ome_virtualhosts %}
		<VirtualHost>
			<Name>{{ vh.name }}</Name>
			<!--Distribution is a value that can be used when grouping the same vhost distributed across multiple servers. This value is output to the events log, so you can use it to aggregate statistics. -->
			<Distribution>{{ vh.distribution }}</Distribution>
			<!-- Settings for multi ip/domain and TLS -->
			<Host>
				<Names>
{% for item in vh.host.names %}
					<Name>{{ item }}</Name>
{% endfor %}
{% if vh.host.names_include_host_public_ip %}
					<Name>{{ hostvars[inventory_hostname].public_ip }}</Name>
{% endif %}
{% if vh.host.names_include_host_public_domains %}
{% for item in hostvars[inventory_hostname].public_domains %}
					<Name>{{ item }}</Name>
{% endfor %}
{% endif %}
				</Names>
{% if ome_tls.enabled %}
				<TLS>
					<CertPath>{{ ome_tls.certpath }}</CertPath>
					<KeyPath>{{ ome_tls.keypath }}</KeyPath>
					<ChainCertPath>{{ ome_tls.chaincertpath }}</ChainCertPath>
				</TLS>
{% endif %}
			</Host>
{% if ome_signedpolicy.enabled %}
			<!-- 	
			Refer https://airensoft.gitbook.io/ovenmediaengine/signedpolicy
			-->
			<SignedPolicy>
				<PolicyQueryKeyName>{{ ome_signedpolicy.policyquerykeyname }}</PolicyQueryKeyName>
				<SignatureQueryKeyName>{{ ome_signedpolicy.signaturequerykeyname }}</SignatureQueryKeyName>
				<SecretKey>{{ ome_signedpolicy.secretkey }}</SecretKey>

				<Enables>
{% if ome_signedpolicy.enables.providers is defined and ome_signedpolicy.enables.providers|length > 0 %}
					<Providers>{% for item in ome_signedpolicy.enables.providers %}{{ item }}{{ "," if not loop.last else "" }}{% endfor %}</Providers>
{% endif %}
{% if ome_signedpolicy.enables.publishers is defined and ome_signedpolicy.enables.publishers|length > 0 %}
					<Publishers>{% for item in ome_signedpolicy.enables.publishers %}{{ item }}{{ "," if not loop.last else "" }}{% endfor %}</Publishers>
{% endif %}
				</Enables>
			</SignedPolicy>
{% endif %}

			<!--
			<AdmissionWebhooks>
				<TargetUrl></TargetUrl>
				<SecretKey></SecretKey>
				<Timeout>3000</Timeout>
				<Enables>
					<Providers>rtmp,webrtc,srt</Providers>
					<Publishers>webrtc,hls,dash,lldash</Publishers>
				</Enables>
			</AdmissionWebhooks>
			-->
{% if ome_server_type == "edge" %}
			<Origins>
{% for origin in vh.origins %}
				<Origin>
					<Location>{{ origin.location }}</Location>
					<Pass>
						<Scheme>{{ origin.scheme }}</Scheme>
						<Urls>
{% for url in origin.urls %}
							<Url>{{ url }}</Url>
{% endfor %}
						</Urls>
					</Pass>
				</Origin>
{% endfor %}
			</Origins>
{% endif %}

{% if ome_server_type == "origin" %}
			<!-- Settings for applications -->
			<Applications>
{% for app in vh.applications %}
				<Application>
					<Name>{{ app.name }}</Name>
					<!-- Application type (live/vod) -->
					<Type>{{ app.type }}</Type>
					<OutputProfiles>
						<!-- Enable this configuration if you want to hardware acceleration using GPU -->
						<HardwareAcceleration>{{ "true" if app.outputprofiles_use_hardwareacceleration else "false" }}</HardwareAcceleration>
{% for op in app.outputprofiles %}
						<OutputProfile>
							<Name>{{ op.name }}</Name>
							<OutputStreamName>{{ op.outputstreamname }}</OutputStreamName>
							<Encodes>
{% for enc in op.encodes %}
								<{{ enc.type }}>
{% if enc.is_bypass %}
									<Bypass>true</Bypass>
{% else %}
									<!--<Bypass>false</Bypass>-->
{% if enc.codec is defined %}
									<Codec>{{ enc.codec }}</Codec>
{% endif %}
{% if enc.bitrate is defined %}
									<Bitrate>{{ enc.bitrate }}</Bitrate>
{% endif %}
{% if enc.framerate is defined %}
									<Framerate>{{ enc.framerate }}</Framerate>
{% endif %}
{% if enc.width is defined %}
									<Width>{{ enc.width }}</Width>
{% endif %}
{% if enc.height is defined %}
									<Height>{{ enc.height }}</Height>
{% endif %}
{% if enc.samplerate is defined %}
									<Samplerate>{{ enc.samplerate }}</Samplerate>
{% endif %}
{% if enc.channel is defined %}
									<Channel>{{ enc.channel }}</Channel>
{% endif %}
{% endif %}
								</{{ enc.type }}>
{% endfor %}
							</Encodes>
						</OutputProfile>
{% endfor %}
					</OutputProfiles>
					<Providers>
{% if 'OVT' in ome_enabled_providers %}
						<OVT />
{% endif %}
{% if 'WebRTC' in ome_enabled_providers %}
						<WebRTC />
{% endif %}
{% if 'RTMP' in ome_enabled_providers %}
						<RTMP />
{% endif %}
{% if 'SRT' in ome_enabled_providers %}
						<SRT />
{% endif %}
{% if 'MPEGTS' in ome_enabled_providers %}
						<MPEGTS>
							<StreamMap>
								<!--
									Set the stream name of the client connected to the port to "stream_${Port}"
									For example, if a client connets to port 4000, OME creates a "stream_4000" stream
									<Stream>
										<Name>stream_${Port}</Name>
										<Port>4000,4001-4004</Port>
									</Stream>
									<Stream>
										<Name>stream_4005</Name>
										<Port>4005</Port>
									</Stream>
								-->
								<Stream>
									<Name>stream_${Port}</Name>
									<Port>4000</Port>
								</Stream>
							</StreamMap>
						</MPEGTS>
{% endif %}
{% if 'RTSPPull' in ome_enabled_providers %}
						<RTSPPull />
{% endif %}
{% if 'WebRTC' in ome_enabled_providers %}
						<WebRTC>
							<Timeout>{{ app.providers.webrtc.timeout }}</Timeout>
						</WebRTC>
{% endif %}
					</Providers>
					<Publishers>
						<AppWorkerCount>{{ app.publishers.appworkercount }}</AppWorkerCount>
						<StreamWorkerCount>{{ app.publishers.streamworkercount }}</StreamWorkerCount>
{% if 'OVT' in ome_enabled_publishers %}
						<OVT />
{% endif %}
{% if 'WebRTC' in ome_enabled_publishers %}
						<WebRTC>
							<Timeout>{{ app.publishers.webrtc.timeout }}</Timeout>
							<Rtx>{{ "true" if app.publishers.webrtc.rtx else "false" }}</Rtx>
							<Ulpfec>{{ "true" if app.publishers.webrtc.ulpfec else "false" }}</Ulpfec>
							<JitterBuffer>{{ "true" if app.publishers.webrtc.jitterbuffer else "false" }}</JitterBuffer>
						</WebRTC>
{% endif %}
{% if 'HLS' in ome_enabled_publishers %}
						<HLS>
							<SegmentDuration>{{ app.publishers.hls.segmentduration }}</SegmentDuration>
							<SegmentCount>{{ app.publishers.hls.segmentcount }}</SegmentCount>
							<CrossDomains>
{% for cdurl in app.publishers.hls.crossdomains %}
								<Url>{{ cdurl }}</Url>
{% endfor %}
							</CrossDomains>
						</HLS>
{% endif %}
{% if 'DASH' in ome_enabled_publishers %}
						<DASH>
							<SegmentDuration>{{ app.publishers.dash.segmentduration }}</SegmentDuration>
							<SegmentCount>{{ app.publishers.dash.segmentcount }}</SegmentCount>
							<CrossDomains>
{% for cdurl in app.publishers.dash.crossdomains %}
								<Url>{{ cdurl }}</Url>
{% endfor %}
							</CrossDomains>
							<!--
								Enable DASH player to obtain UTCTiming from OME using /time?iso&ms API
							-->
							<UTCTiming>
{% if app.publishers.dash.utctiming.scheme is defined %}
								<Scheme>{{ app.publishers.dash.utctiming.scheme }}</Scheme>
{% endif %}
{% if app.publishers.dash.utctiming.value is defined %}
								<Value>{{ app.publishers.dash.utctiming.value }}</Value>
{% endif %}
							</UTCTiming>
						</DASH>
{% endif %}
{% if 'LLDASH' in ome_enabled_publishers %}
						<LLDASH>
							<SegmentDuration>{{ app.publishers.lldash.segmentduration }}</SegmentDuration>
							<CrossDomains>
{% for cdurl in app.publishers.lldash.crossdomains %}
								<Url>{{ cdurl }}</Url>
{% endfor %}
							</CrossDomains>
							<!--
								Use default options for UTCTiming
									- scheme: urn:mpeg:dash:utc:http-xsdate:2014
									- value: /time?iso&ms
							-->
							<UTCTiming>
{% if app.publishers.lldash.utctiming.scheme is defined %}
								<Scheme>{{ app.publishers.lldash.utctiming.scheme }}</Scheme>
{% endif %}
{% if app.publishers.lldash.utctiming.value is defined %}
								<Value>{{ app.publishers.lldash.utctiming.value }}</Value>
{% endif %}
							</UTCTiming>
						</LLDASH>
{% endif %}
{% if 'Thumbnail' in ome_enabled_publishers %}
						<Thumbnail>
							<CrossDomains>
{% for cdurl in app.publishers.thumbnail.crossdomains %}
								<Url>{{ cdurl }}</Url>
{% endfor %}
							</CrossDomains>
						</Thumbnail>
{% endif %}
					</Publishers>
				</Application>
{% endfor %}
			</Applications>
{% endif %}
		</VirtualHost>
{% endfor %}
	</VirtualHosts>
</Server>
